<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: addon.inc.php,v 1.5.4.61 2017-03-03 15:20:57 jpermanne Exp $

if (stristr($_SERVER['REQUEST_URI'], ".inc.php")) die("no access");

function traite_rqt($requete="", $message="") {

	global $dbh,$charset;
	$retour="";
	if($charset == "utf-8"){
		$requete=utf8_encode($requete);
	}
	$res = pmb_mysql_query($requete, $dbh) ;
	$erreur_no = pmb_mysql_errno();
	if (!$erreur_no) {
		$retour = "Successful";
	} else {
		switch ($erreur_no) {
			case "1060":
				$retour = "Field already exists, no problem.";
				break;
			case "1061":
				$retour = "Key already exists, no problem.";
				break;
			case "1091":
				$retour = "Object already deleted, no problem.";
				break;
			default:
				$retour = "<font color=\"#FF0000\">Error may be fatal : <i>".pmb_mysql_error()."<i></font>";
				break;
			}
	}
	return "<tr><td><font size='1'>".($charset == "utf-8" ? utf8_encode($message) : $message)."</font></td><td><font size='1'>".$retour."</font></td></tr>";
}
echo "<table>";

/******************** AJOUTER ICI LES MODIFICATIONS *******************************/

switch ($pmb_bdd_subversion) {
	case '0' :
		// DB - Modification de la table resarc (id resa_planning pour resa issue d'une prvision)
		$rqt = "alter table resa_archive add resarc_resa_planning_id_resa int(8) unsigned not null default 0";
		echo traite_rqt($rqt,"alter resa_archive add resarc_resa_planning_id_resa");
	case '1' :
		//DG - Champs perso demandes
		$rqt = "create table if not exists demandes_custom (
				idchamp int(10) unsigned NOT NULL auto_increment,
				name varchar(255) NOT NULL default '',
				titre varchar(255) default NULL,
				type varchar(10) NOT NULL default 'text',
				datatype varchar(10) NOT NULL default '',
				options text,
				multiple int(11) NOT NULL default 0,
				obligatoire int(11) NOT NULL default 0,
				ordre int(11) default NULL,
				search INT(1) unsigned NOT NULL DEFAULT 0,
				export INT(1) unsigned NOT NULL DEFAULT 0,
				exclusion_obligatoire INT(1) unsigned NOT NULL DEFAULT 0,
				pond int not null default 100,
				opac_sort INT NOT NULL DEFAULT 0,
				PRIMARY KEY  (idchamp)) ";
		echo traite_rqt($rqt,"create table if not exists demandes_custom ");

		$rqt = "create table if not exists demandes_custom_lists (
				demandes_custom_champ int(10) unsigned NOT NULL default 0,
				demandes_custom_list_value varchar(255) default NULL,
				demandes_custom_list_lib varchar(255) default NULL,
				ordre int(11) default NULL,
				KEY i_demandes_custom_champ (demandes_custom_champ),
				KEY i_demandes_champ_list_value (demandes_custom_champ,demandes_custom_list_value)) " ;
		echo traite_rqt($rqt,"create table if not exists demandes_custom_lists ");

		$rqt = "create table if not exists demandes_custom_values (
				demandes_custom_champ int(10) unsigned NOT NULL default 0,
				demandes_custom_origine int(10) unsigned NOT NULL default 0,
				demandes_custom_small_text varchar(255) default NULL,
				demandes_custom_text text,
				demandes_custom_integer int(11) default NULL,
				demandes_custom_date date default NULL,
				demandes_custom_float float default NULL,
				KEY i_demandes_custom_champ (demandes_custom_champ),
				KEY i_demandes_custom_origine (demandes_custom_origine)) " ;
		echo traite_rqt($rqt,"create table if not exists demandes_custom_values ");

	case '2' :
		// NG - Circulation simplifie de priodique
		$rqt = "ALTER TABLE serialcirc ADD serialcirc_simple int unsigned not null default 0" ;
		echo traite_rqt($rqt,"ALTER TABLE serialcirc ADD serialcirc_simple ");

		// NG - Script de construction d'tiquette de circulation simplifie de priodique
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'pmb' and sstype_param='serialcirc_simple_print_script' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'pmb', 'serialcirc_simple_print_script', '', 'Script de construction d\'tiquette de circulation simplifie de priodique' ,'',0)";
			echo traite_rqt($rqt,"insert pmb_serialcirc_simple_print_script into parametres");
		}

	case '3' :
		// AP - Nombre maximum de notices  afficher dans une liste sans pagination
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='max_results_on_a_page' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
				VALUES (0, 'opac', 'max_results_on_a_page', '500', 'Nombre maximum de notices  afficher sur une page, utile notamment quand la navigation est dsactive' ,'d_aff_recherche',0)";
			echo traite_rqt($rqt,"insert max_results_on_a_page into parametres");
		}
	case '4' :
		//JP - taille de certains champs blob trop juste
		$rqt = "ALTER TABLE opac_sessions CHANGE session session MEDIUMBLOB NULL DEFAULT NULL";
		echo traite_rqt($rqt,"ALTER TABLE opac_sessions CHANGE session MEDIUMBLOB");
		$rqt = " select 1 " ;
		echo traite_rqt($rqt,"<b><a href='".$base_path."/admin.php?categ=netbase' target=_blank>VOUS DEVEZ FAIRE UN NETTOYAGE DE BASE (APRES ETAPES DE MISE A JOUR) / YOU MUST DO A DATABASE CLEANUP (STEPS AFTER UPDATE) : Admin > Outils > Nettoyage de base</a></b> ") ;
	case '5' :
		//JP - bouton vider le cache portail
		$rqt = "ALTER TABLE cms_articles ADD article_update_timestamp TIMESTAMP DEFAULT CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP NOT NULL";
		echo traite_rqt($rqt,"ALTER TABLE cms_articles ADD article_update_timestamp");
		$rqt = "UPDATE cms_articles SET article_update_timestamp=article_creation_date";
		echo traite_rqt($rqt,"UPDATE cms_articles SET article_update_timestamp");
		$rqt = "ALTER TABLE cms_sections ADD section_update_timestamp TIMESTAMP DEFAULT CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP NOT NULL";
		echo traite_rqt($rqt,"ALTER TABLE cms_sections ADD section_update_timestamp");
		$rqt = "UPDATE cms_sections SET section_update_timestamp=section_creation_date";
		echo traite_rqt($rqt,"UPDATE cms_sections SET section_update_timestamp");
	case '6' :
		//JP - choix notice nouveaut oui/non par utilisateur en cration de notice
		$rqt = "ALTER TABLE users ADD deflt_notice_is_new INT( 1 ) UNSIGNED NOT NULL DEFAULT '0'";
		echo traite_rqt($rqt,"ALTER TABLE users ADD deflt_notice_is_new");
	case '7' :
		// JP - paramtre mail_adresse_from pour l'envoi de mails
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'pmb' and sstype_param='mail_adresse_from' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'pmb', 'mail_adresse_from', '', 'Adresse d\'expdition des emails. Ce paramtre permet de forcer le From des mails envoys par PMB. Le reply-to reste inchang (mail de l\'utilisateur en DSI ou relance, mail de la localisation ou paramtre opac_biblio_mail  dfaut).\nFormat : adresse_email;libell\nExemple : pmb@sigb.net;PMB Services' ,'',0)";
			echo traite_rqt($rqt,"insert pmb_mail_adresse_from into parametres");
		}
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='mail_adresse_from' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'opac', 'mail_adresse_from', '', 'Adresse d\'expdition des emails. Ce paramtre permet de forcer le From des mails envoys par PMB. Le reply-to reste inchang (mail de l\'utilisateur en DSI ou relance, mail de la localisation ou paramtre opac_biblio_mail  dfaut).\nFormat : adresse_email;libell\nExemple : pmb@sigb.net;PMB Services' ,'a_general',0)";
			echo traite_rqt($rqt,"insert opac_mail_adresse_from into parametres");
		}
	case '8' :
		// JP - blocage des prolongations autorises si relance sur le prt
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='pret_prolongation_blocage' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'opac', 'pret_prolongation_blocage', '0', 'Bloquer la prolongation s\'il y a un niveau de relance valid sur le prt ?\n0 : Non 1 : Oui' ,'a_general',0)";
			echo traite_rqt($rqt,"insert opac_pret_prolongation_blocage into parametres");
		}
	case '9' :
		// JP - Export tableur des prts dans le compte emprunteur
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='empr_export_loans' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
				VALUES (0, 'opac', 'empr_export_loans', '0', 'Afficher sur le compte emprunteur un bouton permettant d\'exporter les prts dans un tableur ?\n0 : Non 1 : Oui' ,'a_general',0)";
			echo traite_rqt($rqt,"insert opac_empr_export_loans into parametres");
		}
	case '10' :
		//Alexandre - Ajout des modes d'affichage avec slection par toiles
		$rqt = "UPDATE parametres SET comment_param=CONCAT(comment_param,'\n 4 : Affichage de la note sous la forme d\'toiles, choix de la note sous la forme d\'toiles.\n 5 : Affichage de la note sous la forme textuelle et d\'toiles, choix de la note sous la forme d\'toiles.') WHERE type_param= 'pmb' AND sstype_param='avis_note_display_mode'";
		echo traite_rqt($rqt,"UPDATE pmb_avis_note_display_mode into parametres");
		$rqt = "UPDATE parametres SET comment_param=CONCAT(comment_param,'\n 4 : Affichage de la note sous la forme d\'toiles, choix de la note sous la forme d\'toiles.\n 5 : Affichage de la note sous la forme textuelle et d\'toiles, choix de la note sous la forme d\'toiles.') WHERE type_param= 'opac' AND sstype_param='avis_note_display_mode'";
		echo traite_rqt($rqt,"UPDATE opac_avis_note_display_mode into parametres");
	case '11' :
		//JP - paramtre utilisateur : localisation par dfaut en bulletinage
		// deflt_bulletinage_location : Identifiant de la localisation par dfaut en bulletinage
		$rqt = "ALTER TABLE users ADD deflt_bulletinage_location INT( 6 ) UNSIGNED NOT NULL DEFAULT 0 AFTER deflt_collstate_location";
		echo traite_rqt($rqt,"ALTER TABLE users ADD deflt_bulletinage_location");
		$rqt = "UPDATE users SET deflt_bulletinage_location=deflt_docs_location";
		echo traite_rqt($rqt,"UPDATE users SET deflt_bulletinage_location=deflt_docs_location");
	case '12' :
		//MB - last_sync_date : Date de la dernire synchronisation du connecteur
		$rqt = "ALTER TABLE connectors_sources ADD last_sync_date DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL";
		echo traite_rqt($rqt,"ALTER TABLE connectors_sources ADD last_sync_date");
	case '13' :
		//JP - audit sur le contenu ditorial
		$res=pmb_mysql_query("SELECT id_section, section_creation_date, section_update_timestamp FROM cms_sections");
		if($res && pmb_mysql_num_rows($res)){
			while ($r=pmb_mysql_fetch_object($res)){
				$rqt = "INSERT INTO audit SET type_obj='".AUDIT_EDITORIAL_SECTION."', object_id='".$r->id_section."', user_id='0', user_name='', type_modif=1, quand='".$r->section_creation_date." 00:00:00', info='' ";
				pmb_mysql_query($rqt);
				if ($r->section_update_timestamp != $r->section_creation_date.' 00:00:00') {
					$rqt = "INSERT INTO audit SET type_obj='".AUDIT_EDITORIAL_SECTION."', object_id='".$r->id_section."', user_id='0', user_name='', type_modif=2, quand='".$r->section_update_timestamp."', info='' ";
					pmb_mysql_query($rqt);
				}
			}
			$rqt = " select 1 " ;
			echo traite_rqt($rqt,"INSERT editorial_sections INTO audit ");
		}
		$res=pmb_mysql_query("SELECT id_article, article_creation_date, article_update_timestamp FROM cms_articles");
		if($res && pmb_mysql_num_rows($res)){
			while ($r=pmb_mysql_fetch_object($res)){
				$rqt = "INSERT INTO audit SET type_obj='".AUDIT_EDITORIAL_ARTICLE."', object_id='".$r->id_article."', user_id='0', user_name='', type_modif=1, quand='".$r->article_creation_date." 00:00:00', info='' ";
				pmb_mysql_query($rqt);
				if ($r->article_update_timestamp != $r->article_creation_date.' 00:00:00') {
					$rqt = "INSERT INTO audit SET type_obj='".AUDIT_EDITORIAL_ARTICLE."', object_id='".$r->id_article."', user_id='0', user_name='', type_modif=2, quand='".$r->article_update_timestamp."', info='' ";
					pmb_mysql_query($rqt);
				}
			}
			$rqt = " select 1 " ;
			echo traite_rqt($rqt,"INSERT editorial_articles INTO audit ");
		}
	case '14' :
		//DG - Paramtre pour afficher ou non le bandeau d'acceptation des cookies
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='cookies_consent' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'opac', 'cookies_consent', '1', 'Afficher le bandeau d\'acceptation des cookies et des traceurs ? \n0 : Non 1 : Oui','a_general',0)";
			echo traite_rqt($rqt,"insert opac_cookies_consent into parametres");
		}
	case '15' :
		//DG - Entrept par dfaut en suppression de notices d'un panier
		$rqt = "ALTER TABLE users ADD deflt_agnostic_warehouse INT(6) UNSIGNED DEFAULT 0 NOT NULL " ;
		echo traite_rqt($rqt,"ALTER users ADD deflt_agnostic_warehouse");
	case '16' :
		// NG : ajout dans les prfrences utilisateur du statut de publication d'article par dfaut en cration d'article
		$rqt = "ALTER TABLE users ADD deflt_cms_article_statut INT(6) UNSIGNED NOT NULL DEFAULT '0' " ;
		echo traite_rqt($rqt,"ALTER users ADD deflt_cms_article_statut ");
		// NG : ajout dans les prfrences utilisateur du type de contenu par dfaut en cration d'article
		$rqt = "ALTER TABLE users ADD deflt_cms_article_type INT(6) UNSIGNED NOT NULL DEFAULT '0' " ;
		echo traite_rqt($rqt,"ALTER users ADD deflt_cms_article_type ");
		// NG : ajout dans les prfrences utilisateur du type de contenu par dfaut en cration de rubrique
		$rqt = "ALTER TABLE users ADD deflt_cms_section_type INT(6) UNSIGNED NOT NULL DEFAULT '0' " ;
		echo traite_rqt($rqt,"ALTER users ADD deflt_cms_section_type ");
	case '17' :
		//NG -  DSI: Ajout de bannette_aff_notice_number pour afficher ou pas le nombre de notices envoyes dans le mail
		$rqt = "ALTER TABLE bannettes ADD bannette_aff_notice_number int unsigned NOT NULL default 1 " ;
		echo traite_rqt($rqt,"ALTER TABLE bannettes ADD bannette_aff_notice_number ");
	case '18' :
		//JP - Personnalisation des colonnes pour l'affichage des tats des collections en gestion
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'pmb' and sstype_param='collstate_data' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'pmb', 'collstate_data', '', 'Colonne des tats des collections, dans l\'ordre donn, spar par des virgules : location_libelle,emplacement_libelle,cote,type_libelle,statut_opac_libelle,origine,state_collections,archive,lacune,surloc_libelle,note,#n : id des champs personnaliss\nLes valeurs possibles sont les proprits de la classe PHP \"pmb/classes/collstate.class.php\".','',0)";
			echo traite_rqt($rqt,"insert pmb_collstate_data = '' into parametres");
		}
	case '19' :
		//JP - champ historique de session trop petit
		$rqt = "ALTER TABLE admin_session CHANGE session session MEDIUMBLOB " ;
		echo traite_rqt($rqt,"ALTER TABLE admin_session CHANGE session MEDIUMBLOB ");
	case '20' :
		//DG - Paramtre pour activer ou non le slecteur d'accs rapide
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='quick_access' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'opac', 'quick_access', '1', 'Activer le slecteur d\'accs rapide ? \n0 : Non 1 : Oui','a_general',0)";
			echo traite_rqt($rqt,"insert opac_quick_access into parametres");
		}
	case '21' :
		// JP - Alertes localises pour les rservations depuis l'OPAC
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'pmb' and sstype_param='resa_alert_localized' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'pmb', 'resa_alert_localized', '0', 'Si les lecteurs sont localiss, restreindre les notifications par email des nouvelles rservations aux utilisateurs selon le site de gestion des lecteurs par dfaut ? \n0 : Non 1 : Oui' ,'',0)";
			echo traite_rqt($rqt,"insert pmb_resa_alert_localized into parametres");
		}
	case '22' :
		//MB - Champ prix trop petit
		$rqt = "ALTER TABLE lignes_actes CHANGE prix prix DOUBLE PRECISION(12,2) unsigned NOT NULL default '0.00'" ;
		echo traite_rqt($rqt,"ALTER lignes_actes CHANGE prix");
	case '23' :
		//MB - Champ montant trop petit
		$rqt = "ALTER TABLE frais CHANGE montant montant DOUBLE PRECISION(12,2) unsigned NOT NULL default '0.00'" ;
		echo traite_rqt($rqt,"ALTER frais CHANGE montant");

		//MB - Champ montant_global trop petit
		$rqt = "ALTER TABLE budgets CHANGE montant_global montant_global DOUBLE PRECISION(12,2) unsigned NOT NULL default '0.00'" ;
		echo traite_rqt($rqt,"ALTER budgets CHANGE montant_global");
	case '24' :
		//DB - script de vrification de saisie d'une notice perso en integration
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'pmb' and sstype_param='catalog_verif_js_integration' "))==0){
			$rqt = "INSERT INTO parametres ( type_param, sstype_param, valeur_param, comment_param,section_param,gestion)
					VALUES ( 'pmb', 'catalog_verif_js_integration', '', 'Script de vrification de saisie de notice en intgration','', 0)";
			echo traite_rqt($rqt,"insert catalog_verif_js_integration into parametres");
		}
	case '25' :
		//DB Maj commentaires mail_methode
		$rqt = "update parametres set comment_param= 'Mthode d\'envoi des mails : \n php : fonction mail() de php\n smtp,hote:port,auth,user,pass,(ssl|tls) : en smtp, mettre O ou 1 pour l\'authentification... ' where sstype_param='mail_methode' ";
		echo traite_rqt($rqt,"update mail_methode comments");
	case '26' :
		//DG - accs rapide pour les paniers de lecteurs
		$rqt = "ALTER TABLE empr_caddie ADD acces_rapide INT NOT NULL default 0";
		echo traite_rqt($rqt,"ALTER TABLE empr_caddie ADD acces_rapide");
	case '27' :
		//JP - Autoriser les montants ngatifs dans les acquisitions
		$rqt = "ALTER TABLE frais CHANGE montant montant DOUBLE(12,2) NOT NULL DEFAULT '0.00'";
		echo traite_rqt($rqt,"ALTER TABLE frais CHANGE montant");
		$rqt = "ALTER TABLE lignes_actes CHANGE prix prix DOUBLE(12,2) NOT NULL DEFAULT '0.00'";
		echo traite_rqt($rqt,"ALTER TABLE lignes_actes CHANGE prix");
	case '28' :
		//JP - update bannette_aff_notice_number pour les bannettes prives
		$rqt = "UPDATE bannettes SET bannette_aff_notice_number = 1 WHERE proprio_bannette <> 0" ;
		echo traite_rqt($rqt,"UPDATE bannettes SET bannette_aff_notice_number ");
	case '29' :
		//JP - Alerter l'utilisateur par mail des nouvelles demandes d'inscription aux listes de circulation
		$rqt = "ALTER TABLE users ADD user_alert_serialcircmail INT(1) UNSIGNED NOT NULL DEFAULT 0 after user_alert_subscribemail";
		echo traite_rqt($rqt,"ALTER TABLE users add user_alert_serialcircmail default 0");
	case '30' :
		//AP - Ajout du nom de groupe dans la table des circulations en cours
		$rqt = "ALTER TABLE serialcirc_circ ADD serialcirc_circ_group_name varchar(255) NOT NULL DEFAULT ''";
		echo traite_rqt($rqt,"ALTER TABLE serialcirc_circ add serialcirc_circ_group_name default ''");
	case '31' :
		//JP - Enrichir les flux rss gnrs par les veilles
		$rqt = "ALTER TABLE docwatch_watches ADD watch_rss_link VARCHAR(255) NOT NULL, ADD watch_rss_lang VARCHAR(255) NOT NULL, ADD watch_rss_copyright VARCHAR(255) NOT NULL, ADD watch_rss_editor VARCHAR(255) NOT NULL, ADD watch_rss_webmaster VARCHAR(255) NOT NULL, ADD watch_rss_image_title VARCHAR(255) NOT NULL, ADD watch_rss_image_website VARCHAR(255) NOT NULL";
		echo traite_rqt($rqt,"ALTER TABLE docwatch_watches add watch_rss_link, watch_rss_lang, watch_rss_copyright, watch_rss_editor, watch_rss_webmaster, watch_rss_image_title, watch_rss_image_website");
	case '32' :
		//JP - Possibilit de nettoyer le contenu HTML dans un OAI entrant
		$rqt = "ALTER TABLE connectors_sources ADD clean_html INT(3) UNSIGNED NOT NULL DEFAULT '0'";
		echo traite_rqt($rqt,"ALTER TABLE connectors_sources add clean_html");
	case '33' :
		//JP - Paramtre inutilis cach
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='categories_categ_sort_records' "))==1){
			$rqt = "update parametres set gestion=1 where type_param= 'opac' and sstype_param='categories_categ_sort_records' ";
			echo traite_rqt($rqt,"update categories_categ_sort_records into parametres");
		}
	case '34' :
		//Alexandre - Prremplissage de la vignette des dpouillements avec la vignette du bulletin
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'pmb' and sstype_param='bulletin_thumbnail_url_article' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
			VALUES (0, 'pmb', 'bulletin_thumbnail_url_article', '0', 'Prremplissage de l\'url de la vignette des dpouillements avec l\'url de la vignette de la notice bulletin en catalogage des priodiques ? \n 0 : Non \n 1 : Oui', '',0) ";
			echo traite_rqt($rqt, "insert pmb_bulletin_thumbnail_url_article=0 into parametres");
		}
	case '35' :
		//JP - date de cration et crateur des paniers
		$rqt = "ALTER TABLE caddie ADD creation_user_name VARCHAR(255) NOT NULL DEFAULT '', ADD creation_date datetime NOT NULL DEFAULT '0000-00-00 00:00:00'";
		echo traite_rqt($rqt,"ALTER TABLE caddie add creation_user_name, creation_date");
		$rqt = "ALTER TABLE empr_caddie ADD creation_user_name VARCHAR(255) NOT NULL DEFAULT '', ADD creation_date datetime NOT NULL DEFAULT '0000-00-00 00:00:00'";
		echo traite_rqt($rqt,"ALTER TABLE empr_caddie add creation_user_name, creation_date");
	case '36':
		//TS - Ajout d'une classe CSS sur les cadres du portail
		$rqt = "ALTER TABLE cms_cadres ADD cadre_css_class VARCHAR(255) NOT NULL DEFAULT '' AFTER cadre_modcache";
		echo traite_rqt($rqt,"ALTER TABLE cms_cadres ADD cadre_css_class");
	case '37':
		//DG - Paramtre pour afficher ou non le lien de gnration d'un flux RSS de la recherche
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='short_url' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'opac', 'short_url', '1', 'Afficher le lien permettant de gnrer un flux RSS de la recherche ? \n0 : Non 1 : Oui','d_aff_recherche',0)";
			echo traite_rqt($rqt,"insert opac_short_url=1 into parametres");
		}
	case '38':
		//VT - Dfinition du mode de gnration du flux rss de recherche (le paramtre opac_short_url doit tre activ)
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='short_url_mode' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'opac', 'short_url_mode', '0', 'Elements gnrs dans le flux rss de la recherche: \n0 : Nouveauts \n1 : Rsultats de la recherche \nPour le mode 1, un nombre de rsultats limite peut tre ajout aprs le mode, il doit tre prcd d\'une virgule\nExemple: 1,30\nSi aucune limite n\'est spcifie, c\'est le paramtre opac_search_results_per_page qui sera pris en compte','d_aff_recherche',0)";
			echo traite_rqt($rqt,"insert opac_short_url_mode=0 into parametres");
		}
	case '39':
		//JP - Message personnalis sur la page de connexion
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'pmb' and sstype_param='login_message' "))==0){
			$rqt = "INSERT INTO parametres ( type_param, sstype_param, valeur_param, comment_param,section_param,gestion)
				VALUES ( 'pmb', 'login_message', '', 'Message  afficher sur la page de connexion','', 0)";
			echo traite_rqt($rqt,"insert pmb_login_message into parametres");
		}
	case '40':
		//JP - viter les codes-barre identiques en cration d'emprunteur
		$rqt = "create table if not exists empr_temp (cb varchar( 255 ) NOT NULL ,sess varchar( 12 ) NOT NULL ,UNIQUE (cb))";
		echo traite_rqt($rqt,"create table  if not exists empr_temp ") ;
	case '41':
		//JP - changement du sparateur des tris de l'opac pour pouvoir utiliser le parse HTML
		$rqt = "UPDATE parametres SET valeur_param=REPLACE(valeur_param,';','||'), comment_param='Afficher la liste droulante de slection d\'un tri ? \n 0 : Non \n 1 : Oui \nFaire suivre d\'un espace pour l\'ajout de plusieurs tris sous la forme : c_num_6|Libelle||d_text_7|Libelle 2||c_num_5|Libelle 3\n\nc pour croissant, d pour dcroissant\nnum ou text pour numrique ou texte\nidentifiant du champ (voir fichier xml sort.xml)\nlibell du tri (optionnel)' WHERE type_param='opac' AND sstype_param='default_sort_list'";
		echo traite_rqt($rqt,"update value into parametres") ;
	case '42':
		///JP - Templates de bannette pour dsi prives
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'dsi' and sstype_param='private_bannette_tpl' "))==0){
			$rqt = "INSERT INTO parametres ( type_param, sstype_param, valeur_param, comment_param,section_param,gestion)
			VALUES ( 'dsi', 'private_bannette_tpl', '0', 'Identifiant du template de bannette  appliquer sur les bannettes prives \nSi vide ou  0, l\'entte et pied de page par dfaut seront utiliss.','', 0)";
			echo traite_rqt($rqt,"insert dsi_private_bannette_tpl into parametres");
		}
	case '43':
		//DG - Modification du commentaire opac_etagere_notices_format
		$rqt = "update parametres set comment_param='Format d\'affichage des notices dans les tagres de l\'cran d\'accueil \n 1 : ISBD seul \n 2 : Public seul \n 4 : ISBD et Public \n 8 : Rduit (titre+auteurs) seul\n 9 : Templates django (Spcifier le nom du rpertoire dans le paramtre notices_format_django_directory)' where type_param='opac' and sstype_param='etagere_notices_format'" ;
		echo traite_rqt($rqt,"UPDATE parametres SET comment_param for opac_etagere_notices_format") ;
	case '44':
		//DG - Modification du commentaire opac_bannette_notices_format
		$rqt = "update parametres set comment_param='Format d\'affichage des notices dans les bannettes \n 1 : ISBD seul \n 2 : Public seul \n 4 : ISBD et Public \n 8 : Rduit (titre+auteurs) seul\n 9 : Templates django (Spcifier le nom du rpertoire dans le paramtre notices_format_django_directory)' where type_param='opac' and sstype_param='bannette_notices_format'" ;
		echo traite_rqt($rqt,"UPDATE parametres SET comment_param for opac_bannette_notices_format") ;
	case '45':
		// VT - Ajout d'un paramtre permettant de masquer les +/- dans les listes de rsultats  l'opac
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='recherche_show_expand' "))==0){
			$rqt = "INSERT INTO parametres ( type_param, sstype_param, valeur_param, comment_param,section_param,gestion)
			VALUES ( 'opac', 'recherche_show_expand', '1', 'Affichage des boutons de dpliage de notice dans les listes de rsultats  l\'OPAC \n0: Boutons non affichs \n1: Boutons affichs','c_recherche', 0)";
			echo traite_rqt($rqt,"insert opac_recherche_show_expand into parametres");
		}
	case '46':
		//DG - Paramtre Portail : Activer l'onglet Toolkits
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'cms' and sstype_param='active_toolkits' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'cms', 'active_toolkits', '0', 'Activer la possibilit de grer des toolkits.\n 0: non \n 1:Oui','',0)";
			echo traite_rqt($rqt,"insert cms_active_toolkits into parametres");
		}

		// DG - Cration de la table pour les toolkits d'aide  la construction d'un portail
		// cms_toolkit_name : Nom du toolkit
		// cms_toolkit_active : Activ Oui/Non
		// cms_toolkit_data : Donnes
		// cms_toolkit_order : Ordre
		$rqt = "create table if not exists cms_toolkits(
				cms_toolkit_name varchar(255) not null default '' primary key,
				cms_toolkit_active int(1) NOT NULL DEFAULT 0,
				cms_toolkit_data text not null,
				cms_toolkit_order int(3) unsigned not null default 0)";
		echo traite_rqt($rqt,"create table cms_toolkits");
	case '47':
		// DG - Veilles : Option pour filtrer les nouveaux items avec une expression boolnne au niveau de la source
		$rqt = "ALTER TABLE docwatch_datasources ADD datasource_boolean_expression varchar(255) not null default '' after datasource_clean_html" ;
		echo traite_rqt($rqt,"ALTER TABLE docwatch_datasources ADD datasource_boolean_expression ");

		// DG - Veilles : Option pour filtrer les nouveaux items avec une expression boolnne au niveau de la veille
		$rqt = "ALTER TABLE docwatch_watches ADD watch_boolean_expression varchar(255) not null default ''" ;
		echo traite_rqt($rqt,"ALTER TABLE docwatch_watches ADD watch_boolean_expression ");

		// DG - Items de veilles : Index sans les mots vides
		$rqt = "ALTER TABLE docwatch_items ADD item_index_sew mediumtext not null default ''" ;
		echo traite_rqt($rqt,"ALTER TABLE docwatch_items ADD item_index_sew ");

		// DG - Items de veilles : Index avec les mots vides
		$rqt = "ALTER TABLE docwatch_items ADD item_index_wew mediumtext not null default ''" ;
		echo traite_rqt($rqt,"ALTER TABLE docwatch_items ADD item_index_wew ");

		// DG - Cration d'une table pour stocker le source des sites surveills
		// datasource_monitoring_website_num_datasource : Identifiant de la source
		// datasource_monitoring_website_upload_date : Date du tlchargement
		// datasource_monitoring_website_content : Contenu
		// datasource_monitoring_website_content_hash : Hash du contenu
		$rqt = "create table if not exists docwatch_datasource_monitoring_website(
				datasource_monitoring_website_num_datasource int(10) unsigned not null default 0 primary key,
				datasource_monitoring_website_upload_date datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
				datasource_monitoring_website_content mediumtext not null,
				datasource_monitoring_website_content_hash varchar(255) not null default '')";
		echo traite_rqt($rqt,"create table docwatch_datasource_monitoring_website");
	case '48' :
		//JP - paramtre utilisateur : paniers du catalogue dplis ou non par dfaut
		$rqt = "ALTER TABLE users ADD deflt_catalog_expanded_caddies INT( 1 ) UNSIGNED NOT NULL DEFAULT 1";
		echo traite_rqt($rqt,"ALTER TABLE users ADD deflt_catalog_expanded_caddies");
	case '49' :
		//Alexandre - Suppression du code pour les articles de priodiques
		$rqt = "UPDATE notices SET code='',update_date=update_date WHERE niveau_biblio='a'";
		echo traite_rqt($rqt,"UPDATE notices SET code for niveau_biblio=a");
	case '50' :
		//JP - Ajout du champ de notice Droit d'usage
		$rqt = "CREATE TABLE if not exists notice_usage (id_usage INT( 8 ) UNSIGNED NOT NULL AUTO_INCREMENT , usage_libelle VARCHAR( 255 ) NOT NULL default '', PRIMARY KEY ( id_usage ) , INDEX ( usage_libelle ) ) " ;
		echo traite_rqt($rqt,"CREATE TABLE notice_usage ");
		$rqt = "ALTER TABLE notices ADD num_notice_usage INT( 8 ) UNSIGNED DEFAULT 0 NOT NULL ";
		echo traite_rqt($rqt,"ALTER TABLE notices ADD num_notice_usage ");
	case '51' :
		//JP - Pouvoir cacher les documents numriques dans les options d'impression des paniers  l'opac
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='print_explnum' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
					VALUES (0, 'opac', 'print_explnum', '1', 'Activer la possibilit d\'imprimer les documents numriques.\n 0: non \n 1: oui','h_cart',0)";
			echo traite_rqt($rqt,"insert opac_print_explnum into parametres");
		}
	case '52' :
		//JP - Ajout d'index sur la table catgories
		$rqt = "alter table categories drop index i_num_thesaurus";
		echo traite_rqt($rqt,"alter table categories drop index i_num_thesaurus");
		$rqt = "alter table categories add index i_num_thesaurus(num_thesaurus)";
		echo traite_rqt($rqt,"alter table categories add index i_num_thesaurus");
	case '53' :
		// NG - Activer le focus sur le champ de recherche a l'opac
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='focus_user_query' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
						VALUES (0, 'opac', 'focus_user_query', '1', 'Activer le focus sur le champ de recherche.\n 0: non \n 1:Oui','c_recherche',0)";
			echo traite_rqt($rqt,"insert opac_focus_user_query into parametres");
		}
	case '54' :
		// VT & DG - Paramtre de transfert de panier anonyme
		// 0 : Non
		// 1 : Sur demande
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='integrate_anonymous_cart' "))==0){
			$rqt = "INSERT INTO parametres (id_param, type_param, sstype_param, valeur_param, comment_param, section_param, gestion)
				VALUES (0, 'opac', 'integrate_anonymous_cart', '0', 'Proposer le transfert des lments du panier lors de l\'authentification.\n 0 : Non\n 1 : Sur demande','h_cart',0)";
			echo traite_rqt($rqt,"insert opac_integrate_anonymous_cart into parametres");
		}
	case '55':
		///JP - Nombre de notices diffuses pour dsi prives
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'dsi' and sstype_param='private_bannette_nb_notices' "))==0){
			$rqt = "INSERT INTO parametres ( type_param, sstype_param, valeur_param, comment_param,section_param,gestion)
		VALUES ( 'dsi', 'private_bannette_nb_notices', '30', 'Nombre maximum par dfaut de notices diffuses dans les bannettes prives.','', 0)";
			echo traite_rqt($rqt,"insert dsi_private_bannette_nb_notices into parametres");
		}
	case '56':
		///JP - Affichage simplifi du panier OPAC
		if (pmb_mysql_num_rows(pmb_mysql_query("select 1 from parametres where type_param= 'opac' and sstype_param='simplified_cart' "))==0){
			$rqt = "INSERT INTO parametres ( type_param, sstype_param, valeur_param, comment_param,section_param,gestion)
		VALUES ( 'opac', 'simplified_cart', '0', 'Affichage simplifi du panier.\n 0 : non \n 1 : oui','h_cart', 0)";
			echo traite_rqt($rqt,"insert opac_simplified_cart=0 into parametres");
		}
	case '57' :
		//JP - Prix de l'exemplaire dans le paramtrage de l'abonnement
		$rqt = "ALTER TABLE abts_abts ADD prix varchar(255) NOT NULL DEFAULT ''";
		echo traite_rqt($rqt,"ALTER TABLE abts_abts ADD prix");
}

/******************** JUSQU'ICI **************************************************/
/* PENSER  faire +1 au paramtre $pmb_subversion_database_as_it_shouldbe dans includes/config.inc.php */
/* COMMITER les deux fichiers addon.inc.php ET config.inc.php en mme temps */

echo traite_rqt("update parametres set valeur_param='".$pmb_subversion_database_as_it_shouldbe."' where type_param='pmb' and sstype_param='bdd_subversion'","Update to $pmb_subversion_database_as_it_shouldbe database subversion.");
echo "<table>";